############################################
#                 Aero AIO                 #
# By Adrien Vermeulen - Released under GPL #
############################################

#this import statement allows access to the karamba functions
import karamba
import re
import os
import sys
from time import time

version = "0.9.1"
conf_pid = None
page = None
current_plugin = None
autoswitch_count = 0
as_state = False
conf = {}
cguiopen = False
last_apply = 0.0
home = os.popen("echo $HOME").read().replace('\n','') + '/'
path = sys.path[1]

if not(os.path.exists(home + ".aero_aio")):
	os.popen("mkdir " + home + ".aero_aio")
if not(os.path.exists(home + ".aero_aio/icons")):
	os.popen("mkdir " + home + ".aero_aio/icons")
if not(os.path.exists(home + ".aero_aio/themes")):
	os.popen("mkdir " + home + ".aero_aio/themes")
if not(os.path.exists(home + ".aero_aio/scripts")):
	os.popen("mkdir " + home + ".aero_aio/scripts")
if not(os.path.exists(home + ".aero_aio/img")):
	os.popen("mkdir " + home + ".aero_aio/img")

sys.path.insert(0, home + ".aero_aio/")

class SkzFile:
	
	def __init__(self, home, path):
		import zipfile
		if not(os.path.exists(home + ".superkaramba/aero_aio")):
			os.popen("mkdir " + home + ".superkaramba/aero_aio")
		file = zipfile.ZipFile(path, "r")
		self.file_list = file.namelist()
		for i in self.file_list:
			if (i.find('scripts/') != -1 and i.find('.py') != -1):
				f = open(home + ".superkaramba/aero_aio/" + i[8:], "w")
				f.write(file.read(i))
				f.close()
		file.close()
		self.conf_file = home + ".superkaramba/aero_aio/conf"
		f = open(self.conf_file, 'w')
		f.write("0.0")
		f.close()
		self.script_dir = home + ".superkaramba/aero_aio/"
		self.skz = True
	
	def pluginDict(self):
		pdict = {}
		for i in self.file_list:
			if (i.find('_aio.py') != -1 and i.find('aero_aio.py') == -1 and i.find('_aio.pyc') == -1 and i.find('_aio.py~') == -1) :
				name = i.replace('\n', '')[:-3]
				pdict[name] = name
		return pdict
	
	def exists(self, name):
		return ((name in self.file_list) or ((name + "/") in self.file_list))
	
	def clean(self):
		os.popen("rm -rf " + home + ".superkaramba/aero_aio")

class Dir:
	
	def __init__(self, path):
		self.path = path
		f = os.popen("ls -1 " + path)
		self.file_list = f.readlines()
		f.close()
		self.conf_file = path + "conf"
		f = open(self.conf_file, 'w')
		f.write("0.0")
		f.close()
		self.script_dir = path + "scripts/"
		self.skz = False
	
	def pluginDict(self):
		pdict = {}
		for i in self.file_list:
			if (i.find('_aio.py') != -1 and i.find('aero_aio.py') == -1 and i.find('_aio.pyc') == -1 and i.find('_aio.py~') == -1) :
				name = i.replace('\n', '')[:-3]
				pdict[name] = name
		return pdict
	
	def exists(self, name):
		return os.path.exists(self.path + name)
	
	
	def clean(self):
		os.popen("rm -rf " + self.conf_file)

if (path.find(".skz") != -1):
	Archive = SkzFile(home, path)
else:
	Archive = Dir(path)

def __globalimport__(module_dict):
	for module in module_dict:
		f = compile("global " + module + "\n" + module + ' = __import__("' + module + '", globals(), locals(), [])', '<string>', 'exec')
		exec f

def ext_pluginDict(home):
	f = os.popen("ls -1 " + home + ".aero_aio")
	file_list = f.readlines()
	f.close()
	pdict = {}
	for i in file_list:
		if (i.find('_aio.py') != -1 and i.find('aero_aio.py') == -1 and i.find('_aio.pyc') == -1 and i.find('_aio.py~') == -1) :
			name = i.replace('\n', '')[:-3]
			pdict[name] = home + ".aero_aio/" + name + ".py"
	return pdict

plugin_dict = Archive.pluginDict()
ext_dict = ext_pluginDict(home)
for plugin in ext_dict:
	plugin_dict[plugin] = ext_dict[plugin]

__globalimport__(plugin_dict)

def restoreConfig(widget):
	global conf, path, home, Archive
	
	default_conf = { "color" : [89, 89, 89],
		"titleColor" : [89, 89, 89],
		"shadow" : False,
		"titleShadow" : False,
		"font" : "sans",
		"titleFont" : "sans",
		"theme" : "themes/default/",
		"ext_themes" : [],
		"icon" : "icons/default/",
		"ext_icons" : [],
		"page_list" : ['sysinfos_aio', 'cpumem_aio', 'partition_aio', 'network_aio', 'clock_aio', 'calendar_aio'],
		"autoswitch" : [60],
		"animation" : True}
	changed = False
	
	if (conf == {}):
		conf = default_conf
		changed = True
	
	print "\n****** Checking and restoring configuration... ******\n"
		
	for key in default_conf:
		try:
			conf[key]
		except:
			print key + "..........: missing, using default value"
			conf[key] = default_conf[key]
			changed = True
		else:
			print key + "..........: OK"
	for plugin in plugin_dict:
		f = compile(plugin + '.default_param', '<string>', 'eval')
		default_param = eval(f)
		for key in default_param:
			try:
				conf[key]
			except:
				print key + "..........: missing, using default value"
				conf[key] = default_param[key]
				changed = True
			else:
				print key + "..........: OK"
	
	print ""
	print "Checking page_list..........:"
	error_list = []
	for i in conf["page_list"]:
		if not( i in plugin_dict ):
			error_list.append(i)
			changed = True
			print "    " + i + ".py doesn't exist!"
		else:
			print "    " + i + ".py present."
		
	theme_path = conf["theme"]
	icon_path = conf["icon"]
	print ""
	print "Checking current theme and icons..........:"
	if not(os.path.exists(theme_path) or Archive.exists(theme_path)):
		changed = True
		print "    '" + conf["theme"] + "' doesn't exist, using default theme!"
		conf["theme"] = default_conf["theme"]
	else:
		print "    '" + conf["theme"] + "' exists: theme OK."
	if not(os.path.exists(icon_path) or Archive.exists(icon_path)):
		changed = True
		print "    '" + conf["icon"] + "' doesn't exist, using default icons!"
		conf["icon"] = default_conf["icon"]
	else:
		print "    '" + conf["icon"] + "' exists: icons OK."
	
	error_themes = []
	if (conf["ext_themes"] != []):
		print ""
		print "Checking added themes..........:"
		for theme in conf["ext_themes"]:
			if not(os.path.exists(theme)):
				changed = True
				error_themes.append(theme)
				print "    '" + theme + "' doesn't exist!"
			else:
				print "    '" + theme + "' present."
	
	error_icons = []
	if (conf["ext_icons"] != []):
		print ""
		print "Checking added icons..........:"
		for icon in conf["ext_icons"]:
			if not(os.path.exists(icon)):
				changed = True
				error_icons.append(icon)
				print "    '" + icon + "' doesn't exist!"
			else:
				print "    '" + icon + "' present."
	
	if changed:
		for i in error_list:
			conf["page_list"].remove(i)
		for theme in error_themes:
			conf["ext_themes"].remove(theme)
		for icon in error_icons:
			conf["ext_icons"].remove(icon)
		karamba.writeConfigEntry(widget, "conf", str(conf))
		print "\n****** Configuration checked and restored ******\n"
	else:
		print "\n****** Configuration checked ******\n"

# def translateImg(widget, img, pos_a, pos_b, a, M):
# 	from math import sqrt
# 	if ( (pos_b[0] - pos_a[0]) != 0  or (pos_b[1] - pos_a[1]) != 0 ):
# 		if ( a < 0 ):
# 			ax = a * (float(pos_b[0] - pos_a[0]) / sqrt((pos_b[0] - pos_a[0])*(pos_b[0] - pos_a[0])+(pos_b[1] - pos_a[1])*(pos_b[1] - pos_a[1])))
# 			ay = a * (float(pos_b[1] - pos_a[1]) / sqrt((pos_b[0] - pos_a[0])*(pos_b[0] - pos_a[0])+(pos_b[1] - pos_a[1])*(pos_b[1] - pos_a[1])))
# 			Tr = sqrt( 2 * float(pos_b[0] - pos_a[0]) / -ax )
# 			T = int(Tr)
# 			Vx = -ax * T
# 			Vy = -ay * T
# 			dx = ((pos_b[0] - pos_a[0]) + int(-0.5 * ax * T * T - Vx * T))
# 			dy = ((pos_b[1] - pos_a[1]) + int(-0.5 * ay * T * T - Vy * T))
# 		elif ( a > 0 ):
# 			ax = a * (float(pos_b[0] - pos_a[0]) / sqrt((pos_b[0] - pos_a[0])*(pos_b[0] - pos_a[0])+(pos_b[1] - pos_a[1])*(pos_b[1] - pos_a[1])))
# 			ay = a * (float(pos_b[1] - pos_a[1]) / sqrt((pos_b[0] - pos_a[0])*(pos_b[0] - pos_a[0])+(pos_b[1] - pos_a[1])*(pos_b[1] - pos_a[1])))
# 			Tr = sqrt( 2 * float(pos_b[0] - pos_a[0]) / ax )
# 			T = int(Tr)
# 			dx = 0
# 			dy = 0
# 			Vx = 0.0
# 			Vy = 0.0
# 		elif ( a == 0 ):
# 			ax = 0.0
# 			ay = 0.0
# 			T = 24
# 			dx = 0
# 			dy = 0
# 			Vx = float(pos_b[0] - pos_a[0]) / T
# 			Vy = float(pos_b[1] - pos_a[1]) / T
# 		
# 		for i in range(M * T + 1):
# 			t = i / float(M)
# 			x = int( 0.5 * ax * t * t + Vx * t) + pos_a[0] + dx
# 			y = int( 0.5 * ay * t * t + Vy * t) + pos_a[1] + dy
# 			karamba.moveImage(widget, img, x, y)
# 			karamba.redrawWidget(widget)

def imgPressed(widget, meter):
	pos = karamba.getImagePos(widget, meter)
	dim = (karamba.getImageWidth(widget, meter), karamba.getImageHeight(widget, meter))
	for i in range(1,22,4):
		percent = (100.0 - i) / 100.0
		new_dim = int(dim[0] * percent), int(dim[1] * percent)
		new_pos = (dim[0] - new_dim[0]) / 2 + pos[0], (dim[1] - new_dim[1]) / 2 + pos[1]
		karamba.resizeImage(widget, meter, new_dim[0], new_dim[1])
		karamba.moveImage(widget, meter,  new_pos[0], new_pos[1])
		karamba.redrawWidget(widget)
	for i in range(1,22,4):
		percent = (79.0 + i) / 100.0
		new_dim = int(dim[0] * percent), int(dim[1] * percent)
		new_pos = (dim[0] - new_dim[0]) / 2 + pos[0], (dim[1] - new_dim[1]) / 2 + pos[1]
		karamba.resizeImage(widget, meter, new_dim[0], new_dim[1])
		karamba.moveImage(widget, meter,  new_pos[0], new_pos[1])
		karamba.redrawWidget(widget)

def loadPage(widget, plugin):
	global page, conf, icon_bar, current_plugin
	theme = conf["theme"]
	color = conf["color"]
	titleColor = conf["titleColor"]
	
	icon_bar.select(widget, plugin, conf["animation"])
	f = compile(plugin + ".Plugin(widget, theme, color, titleColor, conf)", '<string>', 'eval')
	page = eval(f)
	setShadow(widget)
	setColor(widget)
	setFont(widget)
	karamba.redrawWidget(widget)
	current_plugin = plugin
	karamba.writeConfigEntry(widget, "last_page", plugin)

def updateTheme(widget, theme):
	global bg
	karamba.deleteImage(widget, bg)
	bg = karamba.createBackgroundImage(widget, 0, 0, theme + "bg.png")
	karamba.setImagePath(widget, autoswitchImg, theme + "autoswitch.png")
	karamba.setImagePath(widget, stateImg, theme + "play.png")

def applyConfigChanges(widget, _conf):
	global conf, icon_bar, current_plugin, plugin_dict, as_state, page, autoswitchImg, stateImg, autoswitch_count, Archive, home, path
	
	page_reloaded = False
	
	### Updates background and autoswitch button if theme has changed. ###
	if (_conf["theme"] != conf["theme"]):
		updateTheme(widget, _conf["theme"])
	
	### Determines wich plugin is to be loaded. ###
	page_list = _conf["page_list"]
	name = current_plugin
	if (len(_conf["autoswitch"]) > 2):
		name = _conf["autoswitch"][1]
	if ( not(name in page_list) and page_list != []):
		name = page_list[0]
	if (page_list == []):
		name = None
	
	for module in _conf["rem"]:
		try:
			del plugin_dict[module]
			fexec = compile("global " + module + "\ndel " + module, '<string>', 'exec')
			exec fexec
		except:
			print "Unable to delete module."
	__globalimport__(_conf["new"])
	for module in _conf["new"]:
		plugin_dict[module] = module
		if (module in _conf["rem"]):
			updatePage(widget, _conf, name)
			page_reloaded = True
	
	### Updates Icon Bar if needed. ###
	if (_conf["page_list"] != conf["page_list"]) or (_conf["icon"] != conf["icon"]):
		icon_bar.close(widget)
		icon_bar = None
		icon_bar = iconBar(widget, _conf["page_list"], _conf["icon"], _conf["theme"], Archive, home)
		icon_bar.seek(widget, name, False)
	elif (_conf["theme"] != conf["theme"]):
		icon_bar.updateSelectImg(widget, _conf["theme"])
		icon_bar.select(widget, name, False)
	
	### Hide or Show autoswitch toggle button if needed. ###
	if (len(_conf["autoswitch"]) != len(conf["autoswitch"])):
		if ( len(_conf["autoswitch"]) > 2 ):
			karamba.showImage(widget, autoswitchImg)
			karamba.showImage(widget, stateImg)
			as_state = True
		else:
			karamba.hideImage(widget, autoswitchImg)
			karamba.hideImage(widget, stateImg)
			as_state = False
	
	if (name == current_plugin and not(page_reloaded)):
		
		f = compile(name + '.default_param', '<string>', 'eval')
		default_param = eval(f)
		changed = False
		for key in default_param:
			changed = (changed or (_conf[key] != conf[key]))
		
		if (_conf["theme"] != conf["theme"]) or changed:
			updatePage(widget, _conf, name)
			page_reloaded = True
		else:
			if (_conf["color"] != conf["color"]):
				try:
					page.setTextColor(widget, _conf["color"])
				except:
					updatePage(widget, _conf, name)
					page_reloaded = True
			if (_conf["titleColor"] != conf["titleColor"]):
				karamba.changeTextColor(widget, page.title, _conf["titleColor"][0], _conf["titleColor"][1], _conf["titleColor"][2])
			if (_conf["shadow"] != conf["shadow"]):
				try:
					page.setTextShadow(widget, _conf["shadow"])
				except:
					page.shadow(widget, _conf["shadow"])
			if (_conf["titleShadow"] != conf["titleShadow"]):
				karamba.changeTextShadow(widget, page.title, int(_conf["titleShadow"]))
			if (_conf["font"] != conf["font"]):
				try:
					page.setTextFont(widget, _conf["font"])
				except:
					print "!!! This is an old plugin you should update !!!"
			if (_conf["titleFont"] != conf["titleFont"]):
				karamba.changeTextFont(widget, page.title, _conf["titleFont"])
	
	elif (name != None):
		updatePage(widget, _conf, name)
		page_reloaded = True
	
	else:
		page.close(widget)
		del page
		page = EmptyPlugin(widget, _conf["titleColor"], _conf["titleFont"], _conf["titleShadow"])
	
	### Reset autoswitch count ###
	autoswitch_count = 0
	
	### Generate and write 'conf' dict. ###
	if not(page_reloaded):
		conf = _conf
		completeConf()
	del conf["rem"]
	del conf["new"]
	karamba.writeConfigEntry(widget, "conf", str(conf))

def updatePage(widget, _conf, name):
	global conf, page
	conf = _conf
	completeConf()
	page.close(widget)
	del page
	icon_bar.show(widget, name)
	loadPage(widget, name)

def completeConf():
	global conf, home, path, Archive
	conf["home"] = home
	conf["path"] = path
	conf["skz"]  = Archive.skz
	conf["img_dir"] = home + ".aero_aio/img/"
	conf["scripts_dir"] = Archive.script_dir

def updateStateImg(widget, bool):
	global conf, as_state, stateImg
	if bool:
		karamba.setImagePath(widget, stateImg, conf["theme"] + "play.png")
	else:
		karamba.setImagePath(widget, stateImg, conf["theme"] + "pause.png")
	as_state = bool
	karamba.redrawWidget(widget)

def setColor(widget):
	global page, conf
	try:
		page.setTextColor(widget, conf["color"])
	except:
		print "!!! This is an old plugin you should update !!!"
	karamba.changeTextColor(widget, page.title, conf["titleColor"][0], conf["titleColor"][1], conf["titleColor"][2])

def setShadow(widget):
	global page, conf
	try:
		page.setTextShadow(widget, conf["shadow"])
	except:
		print "!!! This is an old plugin you should update !!!"
		page.shadow(widget, conf["shadow"])
	if conf["titleShadow"]:
		karamba.changeTextShadow(widget, page.title, 1)
	else:
		karamba.changeTextShadow(widget, page.title, 0)

def setFont(widget):
	global page, conf
	karamba.changeTextFont(widget, page.title, conf["titleFont"])
	try:
		page.setTextFont(widget, conf["font"])
	except:
		print "!!! This is an old plugin you should update !!!"

class iconBar:
	
	def __init__(self, widget, page_list, icons, theme, archive, home):
		self.num = num = len(page_list)
		if (num > 8):
			num = 8
		space = (290 - num * 32) / (num + 1)
		rest = (290 - num * 32) % (num + 1)
		incr = space + 32
		self.x = x = 35 + space + rest / 2
		self.page_list = page_list
		self.lighted = False
		
		self.selectImg = karamba.createImage(widget, 30, 186, theme + "selected.png")
		self.dim_selectImg = (karamba.getImageWidth(widget, self.selectImg), karamba.getImageHeight(widget, self.selectImg))
		y = 184 + (36 - self.dim_selectImg[1]) / 2
		karamba.moveImage(widget, self.selectImg, 30, y)
		self.icons_dict = {}
		for plugin in page_list:
			file = eval(plugin + ".icon")
			if (os.path.exists(home + ".aero_aio/" + icons + file)):
				path = home + ".aero_aio/" + icons + file
			elif (archive.exists(icons + file) or os.path.exists(icons + file)):
				path = icons + file
			elif (os.path.exists(home + ".aero_aio/default/" + file)):
				path = home + ".aero_aio/default/" + file
			elif (archive.exists("icons/default/" + file)):
				path = "icons/default/" + file
			else:
				path = "icons/default/noicon.png"
			self.icons_dict[plugin] = karamba.createImage(widget, x, 186, path)
			y = 186 + (32 - karamba.getImageHeight(widget, self.icons_dict[plugin])) / 2
			x_real = x + (32 - karamba.getImageWidth(widget, self.icons_dict[plugin])) / 2
			karamba.moveImage(widget, self.icons_dict[plugin], x_real, y)
			karamba.attachClickArea(widget, self.icons_dict[plugin])
			if (x > 300):
				karamba.hideImage(widget, self.icons_dict[plugin])
			x = x + incr
	
	def scrollRight(self, widget):
		img_list = self.page_list + ["select"]
		num = self.num
		for plugin in img_list:
			if (plugin == "select"):
				meter = self.selectImg
			else:
				meter = self.icons_dict[plugin]
			pos = karamba.getImagePos(widget, meter)
			if (pos[0] + 35 > 35 * (num + 1)):
				karamba.moveImage(widget, meter, pos[0] - (num - 1) * 35, pos[1])
				karamba.showImage(widget, meter)
			elif (pos[0] + 35 > 300):
				karamba.hideImage(widget, meter)
				karamba.moveImage(widget, meter, pos[0] + 35, pos[1])
			else:
				karamba.moveImage(widget, meter, pos[0] + 35, pos[1])
		karamba.redrawWidget(widget)
	
	def scrollLeft(self, widget):
		img_list = self.page_list + ["select"]
		num = self.num
		for plugin in img_list:
			if (plugin == "select"):
				meter = self.selectImg
			else:
				meter = self.icons_dict[plugin]
			pos = karamba.getImagePos(widget, meter)
			if (pos[0] < 65):
				karamba.moveImage(widget, meter, pos[0] + (num-1) * 35, pos[1])
				karamba.hideImage(widget, meter)
			elif (pos[0] - 35 < 300):
				karamba.showImage(widget, meter)
				karamba.moveImage(widget, meter, pos[0] - 35, pos[1])
			else:
				karamba.moveImage(widget, meter, pos[0] - 35, pos[1])
		karamba.redrawWidget(widget)
	
	def updateSelectImg(self, widget, theme):
		karamba.setImagePath(widget, icon_bar.selectImg, theme + "selected.png")
		self.dim_selectImg = (karamba.getImageWidth(widget, self.selectImg), karamba.getImageHeight(widget, self.selectImg))
		y = 184 + (36 - self.dim_selectImg[1]) / 2
		karamba.moveImage(widget, self.selectImg, 30, y)
	
	def visible(self, widget, plugin):
		pos = karamba.getImagePos(widget, self.icons_dict[plugin])[0]
		if (pos < 315 and pos >= 35):
			return True
		else:
			return False
	
	def show(self, widget, plugin):
		if (self.num > 8):
			if not(self.visible(widget, plugin)):
				pos = karamba.getImagePos(widget, self.icons_dict[plugin])[0]
				index = pos / 35 - 1
				a = index - 7
				b = self.num - index
				if (a >= b):
					for i in range(b):
						self.scrollRight(widget)
				else:
					for i in range(a):
						self.scrollLeft(widget)
	
	def select(self, widget, plugin, anim):
		from math import sqrt
		meter = self.icons_dict[plugin]
		pos = karamba.getImagePos(widget, meter)[0]
		x1 = karamba.getImagePos(widget, self.selectImg)[0]
		dimImg = self.dim_selectImg[0]
		dimMeter = karamba.getImageWidth(widget, meter)
		x2 = pos + (dimMeter - dimImg) / 2
		y = 184 + (36 - self.dim_selectImg[1]) / 2
		if ( anim and x2 != x1 ):
			ax = -3.5 * (float(x2 - x1) / sqrt((x2 - x1)*(x2 - x1)))
			Tr = sqrt( 2 * float(x2 - x1) / -ax )
			T = int(Tr)
			Vx = -ax * T
			dx = ((x2 - x1) + int(-0.5 * ax * T * T - Vx * T))
			for i in range(8 * T + 1):
				t = i / 8.0
				x = int( 0.5 * ax * t * t + Vx * t) + x1 + dx
				karamba.moveImage(widget, self.selectImg, x, y)
				karamba.redrawWidget(widget)
		else:
			karamba.moveImage(widget, self.selectImg, x2, y)
		karamba.showImage(widget, self.selectImg)
		karamba.redrawWidget(widget)
	
	def seek(self, widget, plugin, anim):
		self.show(widget, plugin)
		self.select(widget, plugin, anim)
	
	def light(self, widget):
		self.lighted = True
		for icon in self.icons_dict.itervalues():
			karamba.changeImageIntensity(widget, icon, 0.07, 0)
		karamba.redrawWidget(widget)
	
	def removeLight(self, widget):
		self.lighted = False
		for icon in self.icons_dict.itervalues():
			karamba.removeImageEffects(widget, icon)
		karamba.redrawWidget(widget)
	
	def close(self, widget):
		for icon in self.icons_dict.itervalues():
			karamba.deleteImage(widget, icon)
		karamba.deleteImage(widget, self.selectImg)

class EmptyPlugin:
	
	def __init__(self, widget, color, font, shadow):
		self.title = karamba.createText(widget, 36, 34, 200, 26, "No plugin found")
		karamba.changeTextSize(widget, self.title, 20)
		karamba.changeTextColor(widget, self.title, color[0], color[1], color[2])
		karamba.changeTextFont(widget, self.title, font)
		karamba.changeTextShadow(widget, self.title, int(shadow))
		self.line = karamba.createImage(widget, 31, 58, "Themes/aero-g/line.png")
	
	def setTextShadow(self, widget, bool):
		pass
	
	def setTextColor(self, widget, color):
		pass
	
	def setTextFont(self, widget, font):
		pass
	
	def close(self, widget):
		karamba.deleteText(widget, self.title)
		karamba.deleteImage(widget, self.line)


#this is called when your widget is initialized
def initWidget(widget):
	global page, Archive, bg, autoswitchImg, as_state, stateImg, conf, plugin_dict, icon_bar, path, home
	
	if not(os.path.exists(Archive.script_dir)):
		Archive.__init__(home, path)
		print "re-__init__"
	
	path = karamba.getThemePath(widget)
	
	for plugin in plugin_dict:
		eval(plugin + '.init(widget)')
	if ( karamba.readConfigEntry(widget, "conf") != None ):
		conf = eval(karamba.readConfigEntry(widget, "conf"))
	restoreConfig(widget)
	conf["home"] = home
	conf["path"] = path
	conf["img_dir"] = home + ".aero_aio/img/"
	conf["scripts_dir"] = Archive.script_dir
	conf["skz"]  = Archive.skz
	
	theme = conf["theme"]
	bg = karamba.createBackgroundImage(widget, 0, 0, theme + "bg.png")
	
	icon_bar = iconBar(widget, conf["page_list"], conf["icon"], conf["theme"], Archive, home)
	
	autoswitchImg = karamba.createImage(widget, 302, 36, theme + "autoswitch.png")
	stateImg = karamba.createImage(widget, 311, 43, theme + "play.png")
	karamba.attachClickArea(widget, autoswitchImg)
	if ( len(conf["autoswitch"]) > 2 ):
		karamba.showImage(widget, autoswitchImg)
		karamba.showImage(widget, stateImg)
		as_state = True
	else:
		karamba.hideImage(widget, autoswitchImg)
		karamba.hideImage(widget, stateImg)
		as_state = False
	
	test = karamba.readConfigEntry(widget, "last_page")
	if ( test != None and test in conf["page_list"]):
		icon_bar.show(widget, test)
		loadPage(widget, test)
	elif (conf["page_list"] != []):
		loadPage(widget, conf["page_list"][0])
	else:
		page = EmptyPlugin(widget, conf["titleColor"], conf["titleFont"], conf["titleShadow"])
	
	karamba.redrawWidget(widget)
	
	karamba.addMenuConfigOption(widget, "confclick", "Configure theme")
	karamba.setMenuConfigOption(widget, "confclick", 0)

#This is called when your widget is closed.  You can use this to clean
#up open files, etc.  You don't need to delete text and images in your
#theme.  That is done automatically.  This callback is just for cleaning up
#external things.  Most people don't need to put anything here.
def widgetClosed(widget):
	global Archive
	Archive.clean()

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
	global page, autoswitch_count, as_state, icon_bar, cguiopen, last_apply, conf
	
	autoswitch = conf["autoswitch"]
	
	if as_state:
		if ( len(autoswitch) > 2 and (autoswitch_count % autoswitch[0]) == 0 ):
			page.close(widget)
			del page
			index = autoswitch_count / autoswitch[0]
			if ( index + 1 >= len(autoswitch) ):
				autoswitch_count = 0
				index = 0
			plugin = autoswitch[index + 1]
			icon_bar.show(widget, plugin)
			loadPage(widget, plugin)
		autoswitch_count = autoswitch_count + 1
	
	if cguiopen:
		f = open(Archive.conf_file, 'r')
		conf_time = eval(f.readline())
		if (conf_time > last_apply):
			last_apply = conf_time
			print "** Applying :" + str(conf_time) + " **"
			confr = eval(f.readline())
			f.close()
			f = open(Archive.conf_file, 'w')
			f.write("0.0")
			applyConfigChanges(widget, confr)
		f.close()
	
	try:
		page.update(widget)
	except:
		pass
	#karamba.redrawWidget(widget)

#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
	global Archive, conf_pid, conf, plugin_dict, home, path, cguiopen, last_apply
	
	if ( key == "confclick" ):
		karamba.setMenuConfigOption(widget, "confclick", 0)
		name2plugin_dict = {}
		plugin2name_dict = {}
		for plugin in plugin_dict:
			f = compile(plugin + ".plugin_name", '<string>', 'eval')
			name = eval(f)
			name2plugin_dict[name] = plugin
			plugin2name_dict[plugin] = name
		arg = conf
		arg['skz'] = Archive.skz
		arg['home'] = home
		arg['theme_path'] = path
		arg['name2plugin_dict'] = name2plugin_dict
		arg['plugin2name_dict'] = plugin2name_dict
		arg['plugin_dict'] = plugin_dict
		conf_command = ["python", Archive.script_dir + "config_dialog.py", str(arg)]
		conf_pid = karamba.executeInteractive(widget, conf_command)
		cguiopen = True
		last_apply = time()

def commandOutput(widget, pid, output):
	global conf_pid, page, Archive, icon_bar, conf, as_state, autoswitch_count, current_plugin, home, path, plugin_dict, cguiopen
	
	if ( pid == conf_pid ):
		cguiopen = False
		if ((output.replace('\n','')) == "CONF SAVED SUCCESSFULLY"):
			f = open(Archive.conf_file, 'r')
			conf_str = f.readline()
			conf_str = f.readline()
			f.close()
			f = open(Archive.conf_file, 'w')
			f.write("0.0")
			f.close()
			f = compile("confr = " + conf_str, '<string>', 'exec')
			exec f
			applyConfigChanges(widget, confr)
	
	try:
		page.commandOutput(widget, pid, output)
	except:
		pass


def widgetClicked(widget, x, y, button):
	global conf, as_state, icon_bar
	if (icon_bar.num > 8):
		if ( y >= 186 and y < 218 and x >= 30 and x <= 330 and not( as_state and len(conf["autoswitch"]) > 2 )):
			if (button == 4):
				icon_bar.scrollRight(widget)
			if (button == 5):
				icon_bar.scrollLeft(widget)
	try:
		page.widgetClicked(widget, x, y, button)
	except:
		pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  button = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetMouseMoved(widget, x, y, button):
	global conf, icon_bar
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
	if (icon_bar.num > 8 and not(as_state)):
		if ( y >= 186 and y < 218 and x >= 30 and x <= 330 ):
			if not(icon_bar.lighted):
				icon_bar.light(widget)
		else:
			if icon_bar.lighted:
				icon_bar.removeLight(widget)
	try:
		page.widgetMouseMoved(widget, x, y, button)
	except:
		pass


#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
	try:
		page.menuItemClicked(widget, menu, id)
	except:
		pass


#This gets called when a meter (image, text, etc) is clicked.
# NOTE you must use attachClickArea() to make a meter
# clickable.  
#  widget = reference to your theme
#  meter = the meter clicked
#  button = the button clicked (see widgetClicked for button numbers)
def meterClicked(widget, meter, button):
	global page, as_state, icon_bar
	try:
		imgPressed(widget, meter)
	except:
		pass
	
	if ( button == 1 ):
		for key in icon_bar.icons_dict:
			if ( meter == icon_bar.icons_dict[key] ):
				page.close(widget)
				del page
				loadPage(widget, key)
	
	if ( meter == autoswitchImg and button == 1 ):
		if as_state:
			updateStateImg(widget, False)
		else:
			updateStateImg(widget, True)
	
	try:
		page.meterClicked(widget, meter, button)
	except:
		pass


#This gets called when an item is dropped on this widget.
# NOTE you have to call acceptDrops() before your widget will accept drops.
#  widget = reference to your theme
#  dropText = the text of the dropped item (probably a URL to it's location in KDE)
def itemDropped(widget, dropText):
	try:
		page.itemDropped(widget, dropText)
	except:
		pass


#This gets called when a new program is LOADING in KDE.  When it is done
#loading, startupRemoved() is called, followed by taskAdded().
#  widget = reference to your widget
#  task = A refence to the task that is starting.  
def startupAdded(widget, startup):
    pass

#This gets called when a new program is done LOADING in KDE.
#  widget = reference to your widget
#  task = A refence to the task that just finished loading.  
def startupRemoved(widget, startup):
    pass

#This is called every time a new task (program) is started in KDE.
#  widget = reference to your widget
#  task = A refence to the new task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def taskAdded(widget, task):
    pass

#This is called everytime a task (program) is closed in KDE.
#  widget = reference to your widget
#  task = A refence to the task.  
def taskRemoved(widget, task):
    pass

#This is called everytime a different task gains focus (IE, the user clicks
#on a different window).  
#  widget = reference to your widget
#  task = A refence to the task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def activeTaskChanged(widget, task):
    pass

#This is called everytime there is a key press in any focused input field
#  widget = reference to your widget
#  meter = reference to an input box
#  char = the key that was pressed
def keyPressed(widget, meter, char):
	try:
		page.keyPressed(widget, meter, char)
	except:
		pass


# This will be printed when the widget loads.
print "Loaded Aero-AIO python extension!"
